// G`֐
unit UnitGraph;

interface

uses
   Graphics, UnitFunc, UnitClip, UnitGVar ;

procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);

procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;
procedure GL_LINE2(C:TCanvas;x1,y1,x2,y2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;

procedure GL_PAPERFRAME(C:TCanvas) ;
procedure GL_ALLDAT(C:TCanvas) ;

implementation

// ʂNA
procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
begin
   with C do begin
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(x1,y1,x2,y2);
   end;
end;

// o[oh`
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      MoveTo(rx1,ry1);
      LineTo(rx2,ry2);
   end;
end;

// o[oh``
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      Rectangle(rx1,ry1,rx2,ry2);
   end;
end;

// ========== ========== ==========

// [mm]}
procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;
var
   i : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   ax1,ay1,ax2,ay2 : integer ;
begin
   wx1 := x1 ;    wy1 := y1 ;
   wx2 := x2 ;    wy2 := y2 ;
   i := ClipLine(wx1,wy1,wx2,wy2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i < 2) then begin
      ax1 := Round( (wx1 - WD_x1 ) * MM_dot );
      ay1 := Round(-(wy1 - WD_y2 ) * MM_dot );
      ax2 := Round( (wx2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(wy2 - WD_y2 ) * MM_dot );
      C.MoveTo(ax1,ay1);
      C.LineTo(ax2,ay2);
   end;
end;

// [mm]}ilj
//    ptnn : p^[
//    ptns : p^[iړxZρj
//    ptn1 : in : }Jnp^[
//           out: }I̐p^[
//    ptn2 : in : p^[̊Jn
//           out: }I̐p^[̏I
procedure GL_LINE2(C:TCanvas;x1,y1,x2,y2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
var
   a : double ;   // Xpx[rad]
   l : double ;   // 
   lx1,ly1,lx2,ly2,ll,p : double ;
   ii : integer ;
   f : Boolean ;
begin
   if (ptnn <= 1) then
      GL_LINE(C,x1,y1,x2,y2)
   else begin
      a  := GetAngle(x1,y1,x2,y2);
      l  := GetLength(x1,y1,x2,y2);
      lx1:= x1 ;
      ly1:= y1 ;
      ii := ptn1 ;
      ll := 0 ;
      p  := Abs(ptns[ii]) - ptn2 ;
      f  := True ;
      while(f) do begin
         if (ll+p >= l) then begin
            p := l - ll;
            f := False ;
         end;
         lx2 := lx1 + p*Cos(a);
         ly2 := ly1 + p*Sin(a);
         if (ptns[ii] > 0.0) then GL_LINE(C,lx1,ly1,lx2,ly2);
         // ł̓p^[0̓_ɂ͖Ήł
         lx1 := lx2 ;
         ly1 := ly2 ;
         ll  := ll + p ;
         if (f) then begin
            Inc(ii);
            if (ii >= ptnn) then ii := 0;
            p := Abs(ptns[ii]);
         end;
      end;
      ptn1 := ii;
      ptn2 := p;
   end;
end;

// ========== ========== ==========

// pg}
procedure GL_PAPERFRAME(C:TCanvas) ;
var
   x1,y1,x2,y2 : Double ;
   i : integer ;
   ax1,ay1 : Integer ;
begin
   C.Pen.Mode  := pmCopy ;
   C.Pen.Color := clBlue ;
   C.Pen.Width := 0 ;
   C.Pen.Style := psSolid;

   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 := -PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 :=  PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 := -PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 :=  PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   // _
   i := ClipPoint(0.0,0.0,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0) then begin
      ax1 := Round( ( 0.0 - WD_x1 ) * MM_dot );
      ay1 := Round(-( 0.0 - WD_y2 ) * MM_dot );
      with C do begin
         Pen.Color := clRed ;
         MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
         MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      end;
   end;
end;

// Svf}
procedure GL_ALLDAT(C:TCanvas) ;
var
   i,j,jj : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   k,k1,k2,kc,kl,kwi : integer ;
   kw : double ;
   ptns : array of Double ;   // }p^[(ړxZ)
   ptnn : integer ;           // p^[
   ptn1 : integer ;           // p^[}݈ʒu(ptnnNo.)
   ptn2 : double ;            // p^[}݈ʒu(mm)
begin
   with C do begin
      Pen.Mode  := pmCopy ;
      Pen.Color := clBlack ;
      for k:=0 to LayTblN-1 do begin
         if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
         if not(LayTbl[k].dsp)  then continue;  // Display ͎̃C
         for i:=0 to Dat_N-1 do begin
            if (LayTbl[k].no = Dat[i].lay) then begin
               k1 := LayTbl[k].dc ; // CF
               k2 := LayTbl[k].dl ; // C
               kw := LayTbl[k].wid; // C
               // C
               if (Dat[i].col <> -1) then k1 := Dat[i].col ;   // CFł͂Ȃ
               if (Dat[i].lin <> -1) then k2 := Dat[i].lin ;   // Cł͂Ȃ
               if (Dat[i].wid >=0.0) then kw := Dat[i].wid ;   // Cł͂Ȃ
               // F
               kc := 0 ;
               if (k1 >= 0) then begin
                  if (k1 <= ColTblN) then kc := ColTbl[k1].val;
               end
               else begin
                  k1 := Abs(k1) - 2 ;
                  if (k1 >= 0)and(k1 <= 256*256*256-1) then kc := k1;
               end;

               ptnn := 0 ;
               ptns := nil ;
               if (SC_mode) then begin // ڍו\[h
                  // 
                  for j:=0 to LinTblN-1 do begin
                     if (LinTbl[j].no = k2) then begin
                        ptnn := LinTbl[j].n ;
                        SetLength(ptns,ptnn);
                        for jj:=0 to ptnn-1 do begin
                           ptns[jj] := LinTbl[j].ptn[jj] * LayTbl[k].lsc ;
                        end;
                        break;
                     end;
                  end;
                  // 
                  if (kw*MM_dot > 200.0) then begin
                     kwi := 200;
                  end
                  else if (kw*MM_dot <= 0.0) then
                     kwi := 0
                  else
                     kwi := Round(kw*MM_dot);
                  //
                  Pen.Color := kc ;
                  Pen.Style := psSolid ;
                  Pen.Width := kwi ;
               end
               else begin  // ȈՕ\[h
                  // 
                  kl := 0 ;
                  for j:=0 to LinTblN-1 do begin
                     if (LinTbl[j].no = k2) then begin
                        kl := LinTbl[j].val;
                        break;
                     end;
                  end;
                  //
                  Pen.Color := kc ;
                  Pen.Style := psSolid ;
                  Pen.Width := 0 ;
                  Case(kl)of
                  1: Pen.Style := psDash;
                  2: Pen.Style := psDot;
                  3: Pen.Style := psDashDot;
                  4: Pen.Style := psDashDotDot;
                  end;
               end;

               wx1 := Dat[i].x1 *LayTbl[k].sc;
               wy1 := Dat[i].y1 *LayTbl[k].sc;
               wx2 := Dat[i].x2 *LayTbl[k].sc;
               wy2 := Dat[i].y2 *LayTbl[k].sc;
               if (SC_mode) then begin // ڍו\[h
                  ptn1 := 0 ;
                  ptn2 := 0.0 ;
                  GL_LINE2(C,wx1,wy1,wx2,wy2,ptnn,ptns,ptn1,ptn2);
               end
               else begin  // ȈՕ\[h
                  GL_LINE(C,wx1,wy1,wx2,wy2);
               end;

               ptns := nil ;  // ꎞIEp^[
            end;
         end;
      end;
   end;
end;

end.
 